import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.util.ArrayList;

import javax.swing.JPanel;

@SuppressWarnings("serial")
public class Panel extends JPanel{
	
	private static final int INCNONE =  0;
	private static final int INCLEFT =  1;
	private static final int INCRIGHT = 2;
	
	
	public Point pt_ = null;
	
	private ArrayList<Point> pts_ = new ArrayList<Point>();
	
	public void paintComponent(Graphics g){
		
		Dimension d = getSize();
		g.fillRect(0, 0, d.width, d.height);
		if (pts_.size() < 3) return;
		
		if ( (pt_ != null) && isInside(pt_) ){
			g.setColor(Color.GREEN);
			g.drawString("true", pt_.x, pt_.y);
		}
		else{
			g.setColor(Color.RED);
			g.drawString("false", pt_.x, pt_.y);
			
		}
		
		g.setXORMode(getForeground());
		
		int[] xpts = new int[pts_.size()];
		int[] ypts = new int[pts_.size()];
		
		for (int i = 0; i < pts_.size(); i++){
			xpts[i] = pts_.get(i).x;
			ypts[i] = pts_.get(i).y;
		}
		g.fillPolygon(xpts, ypts, pts_.size());
		
		/*for(int i = 0; i < pts_.size(); i++){
			g.drawLine(0, pts_.get(i).y, d.width, pts_.get(i).y);
		}*/
	
	}
	
	private boolean isInside(Point pt){
		
		int l = 0, r = 0;
		
		//number of sides
		int ns = pts_.size();
		
		int res;
		
		for(int i = 0; i < ns - 1; i++ ){
			
			res = checkSide(pts_.get(i).x, 
							pts_.get(i).y,
							pts_.get(i+1).x,
							pts_.get(i+1).y,
							pt.x, pt.y);
			
			if (res == INCLEFT)
				l++;
			else if (res == INCRIGHT)
				r++;
			
		}
		
		res = checkSide(pts_.get(ns - 1).x, 
						pts_.get(ns - 1).y,
						pts_.get(0).x,
						pts_.get(0).y,
						pt.x, pt.y);
		if (res == INCLEFT)
			l++;
		else if (res == INCRIGHT)
			r++;
		
		return (l%2 > 0) || (r%2 > 0);
	}
	
	private int checkSide(int x1, int y1, int x2, int y2, int px, int py){
		int xint;
		int res = INCNONE;
		
		if ( (Math.min(y1, y2) <= py) && (Math.max(y1, y2) > py) ){
				
				xint = x1 + ( py - y1 )*( x2 - x1 )/( y2 - y1);
				      
				if (xint < px) 
					res = INCLEFT;
				else
					res = INCRIGHT;
		}
		return res;
	}

	public void addPoints(Point pt) {
		pts_.add(pt);
	}


	public void clear(){
		pts_.clear();
		pt_ = null;
		repaint();

	}

}
